diff -r -C 2 -P ../AmiPhone_1.92/ciatimer.c ./ciatimer.c
*** ../AmiPhone_1.92/ciatimer.c	Sat Nov 16 23:46:44 1996
--- ./ciatimer.c	Sun Mar  1 20:47:16 1998
***************
*** 823,834 ****
  			/* Set SEL to 0 for decrease, 1 for increase */
  			if (BRaise == TRUE) SetParallelBits(EVENT_NONE,SAMPBIT_SELSET);
! 				       else SetParallelBits(EVENT_NONE,SAMPBIT_SELCLR);
  				
  			/* Now toggle PB7 */
! 		        pciaa->ciaprb  &= ~(0x80);	/* Gain control goes to zero */
  			Delay(1);
! 		        pciaa->ciaprb  |= 0x80;		/* And back to one.  This is the trigger. */
  		}
! 		ChangeInputChannel(ubInputChannel);	
  		break;
  	}
--- 884,895 ----
  			/* Set SEL to 0 for decrease, 1 for increase */
  			if (BRaise == TRUE) SetParallelBits(EVENT_NONE,SAMPBIT_SELSET);
! 					   else SetParallelBits(EVENT_NONE,SAMPBIT_SELCLR);
  				
  			/* Now toggle PB7 */
! 				pciaa->ciaprb  &= ~(0x80);	/* Gain control goes to zero */
  			Delay(1);
! 				pciaa->ciaprb  |= 0x80;		/* And back to one.	 This is the trigger. */
  		}
! 		ChangeInputChannel(ubInputChannel); 
  		break;
  	}
***************
*** 850,863 ****
  	switch(ubSamplerType)
  	{
- 	   case SAMPLER_DELFINA:
- 		taglist[0].ti_Tag = DA_MicIsLine;	taglist[0].ti_Data = (nNewValue==0);
- 		taglist[1].ti_Tag = DA_HighPass;	taglist[1].ti_Data = (nNewValue==20);
- 		taglist[2].ti_Tag = TAG_DONE;		taglist[2].ti_Data = NULL;
- 		Delf_SetAttrsA(taglist);
- 		break;
- 
  	   case SAMPLER_TOCCATA:
! 		taglist[0].ti_Tag  = PAT_MicGain;       taglist[0].ti_Data = (nNewValue > 0);
! 		taglist[1].ti_Tag  = TAG_DONE; 		taglist[1].ti_Data = NULL;
  		T_SetPart(taglist);
  		break;
--- 911,917 ----
  	switch(ubSamplerType)
  	{
  	   case SAMPLER_TOCCATA:
! 		taglist[0].ti_Tag  = PAT_MicGain;		taglist[0].ti_Data = (nNewValue > 0);
! 		taglist[1].ti_Tag  = TAG_DONE;		taglist[1].ti_Data = 0;
  		T_SetPart(taglist);
  		break;
***************
*** 873,878 ****
  /* 
   * This routine sets up the interval timer we allocated with
!  * AddICRVector().  Note that we may have alreay received one, or
!  * more interrupts from our timer.  Make no assumptions about the
   * initial state of any of the hardware registers we will be using.
   *
--- 927,932 ----
  /* 
   * This routine sets up the interval timer we allocated with
!  * AddICRVector().	Note that we may have alreay received one, or
!  * more interrupts from our timer.	Make no assumptions about the
   * initial state of any of the hardware registers we will be using.
   *
***************
*** 886,937 ****
  	{
  		case SAMPLER_PERFECT:
! 		     pciaa->ciaddrb  = 0xC0;	/* high two bits are output/control bits on the PerfectSound! */
! 		     pciaa->ciaprb  |= 0xC0;	/* PB6, PB7 both high when sampling? */
! 		     SetDirectionBits(SAMPBIT_BUSYCLR);	/* per generic.source? */
! 		     break;
! 				     
! 		case SAMPLER_TOCCATA: case SAMPLER_AHI: case SAMPLER_DELFINA:
! 		     /* Don't call StartTimer() with these sampler types, fruit loop! */
! 		     return(FALSE);
! 		     break;
  		
  		case SAMPLER_SOMAGIC:
! 		     pciaa->ciaddrb  = 0x00;	/* all bits: input mode */
! 		     /* for this model, BUSY is used as an output also */
! 		     SetDirectionBits(SAMPBIT_SELSET | SAMPBIT_POUTSET | SAMPBIT_BUSYSET);
! 		     break; 
  		
  		case SAMPLER_CUSTOM:
! 		     /* Make all data bits input */
! 		     pciaa->ciaddrb  = 0x00;
! 		     /* User-customizable set of control direction bits */
! 		     SetDirectionBits(ubCustDir);
! 		     /* User-customizable set of control data bits */
! 		     SetParallelBits(EVENT_START, ubCustStart);
! 		     break;
! 	 	
  		default:
! 		     pciaa->ciaddrb  = 0x00;	/* all bits: input mode */
! 		     SetDirectionBits(SAMPBIT_SELSET | SAMPBIT_POUTSET | SAMPBIT_BUSYCLR);
! 		     break;
  	}
  
  	UNLESS(AllocSamplingBuffer(ulSmallestArraySize)) return(FALSE);
  	
! 	IntData.pubSampleAt   = AMIGA_HARDWARE_SAMPLE_ADDRESS;		/* default = parallel hardware */
! 	IntData.stTask        = FindTask(NULL);
  	IntData.ulHalfSignal  = (1<<sighalf);
  	IntData.ulFullSignal  = (1<<sigfull);
! 	IntData.ulShiftLeft   = (ULONG) nAmpShift;
! 	IntData.ulByteSum     = 0L;
  	IntData.ulSaveByteSum = 0L;
  	IntData.ulThreshhold  = (nPreSendQLen == 0) ? ((ULONG) ((nMinSampleVol*255)/100)) : 0L;
! 	IntData.uwCiavals     = uwMicros;
! 	IntData.uwClearCode   = (ft->BUsingCIAB) ? INTF_EXTER : INTF_PORTS;
! 	IntData.BIdle	      = 1L;
  	
! 	ChangeInputChannel(ubInputChannel);	/* select channel for input if possible */
  
! 	ulLastVolume = SILENCE;	
  	TransmitData(0,0,0);
  		
--- 940,992 ----
  	{
  		case SAMPLER_PERFECT:
! 			 pciaa->ciaddrb	 = 0xC0;	/* high two bits are output/control bits on the PerfectSound! */
! 			 pciaa->ciaprb	|= 0xC0;	/* PB6, PB7 both high when sampling? */
! 			 SetDirectionBits(SAMPBIT_BUSYCLR); /* per generic.source? */
! 			 break;
! 					 
! 		case SAMPLER_TOCCATA:
! 		case SAMPLER_AHI:
! 			 /* Don't call StartTimer() with these sampler types, fruit loop! */
! 			 return(FALSE);
! 			 break;
  		
  		case SAMPLER_SOMAGIC:
! 			 pciaa->ciaddrb	 = 0x00;	/* all bits: input mode */
! 			 /* for this model, BUSY is used as an output also */
! 			 SetDirectionBits(SAMPBIT_SELSET | SAMPBIT_POUTSET | SAMPBIT_BUSYSET);
! 			 break; 
  		
  		case SAMPLER_CUSTOM:
! 			 /* Make all data bits input */
! 			 pciaa->ciaddrb	 = 0x00;
! 			 /* User-customizable set of control direction bits */
! 			 SetDirectionBits(ubCustDir);
! 			 /* User-customizable set of control data bits */
! 			 SetParallelBits(EVENT_START, ubCustStart);
! 			 break;
! 		
  		default:
! 			 pciaa->ciaddrb	 = 0x00;	/* all bits: input mode */
! 			 SetDirectionBits(SAMPBIT_SELSET | SAMPBIT_POUTSET | SAMPBIT_BUSYCLR);
! 			 break;
  	}
  
  	UNLESS(AllocSamplingBuffer(ulSmallestArraySize)) return(FALSE);
  	
! 	IntData.pubSampleAt	  = AMIGA_HARDWARE_SAMPLE_ADDRESS;		/* default = parallel hardware */
! 	IntData.stTask		  = FindTask(NULL);
  	IntData.ulHalfSignal  = (1<<sighalf);
  	IntData.ulFullSignal  = (1<<sigfull);
! 	IntData.ulShiftLeft	  = (ULONG) nAmpShift;
! 	IntData.ulByteSum	  = 0L;
  	IntData.ulSaveByteSum = 0L;
  	IntData.ulThreshhold  = (nPreSendQLen == 0) ? ((ULONG) ((nMinSampleVol*255)/100)) : 0L;
! 	IntData.uwCiavals	  = uwMicros;
! 	IntData.uwClearCode	  = (ft->BUsingCIAB) ? INTF_EXTER : INTF_PORTS;
! 	IntData.BIdle		  = 1L;
  	
! 	ChangeInputChannel(ubInputChannel); /* select channel for input if possible */
  
! 	ulLastVolume = SILENCE; 
  	TransmitData(0,0,0);
  		
***************
*** 962,972 ****
  	}
  
! 	IntData.pubCiahi      = ft->ciahi;
! 	IntData.pubCialo      = ft->cialo;
  		
  	/* Modify control register within Disable().  This is done to avoid
  	 * race conditions since our compiler may generate code such as:
  	 *
! 	 * 	value = Read hardware byte
  	 *	AND value with MASK
  	 *	Write value to hardware byte
--- 1017,1027 ----
  	}
  
! 	IntData.pubCiahi	  = ft->ciahi;
! 	IntData.pubCialo	  = ft->cialo;
  		
  	/* Modify control register within Disable().  This is done to avoid
  	 * race conditions since our compiler may generate code such as:
  	 *
! 	 *	value = Read hardware byte
  	 *	AND value with MASK
  	 *	Write value to hardware byte
***************
*** 1036,1050 ****
  	/* Initialize arg struct for inthandler */
  	Disable();
! 	IntData.pubIndex      = pubAllocedArray;
! 	IntData.pubArray      = pubAllocedArray;
  	if (pubAllocedArray)
  	{
  		IntData.pubHalfIndex  = &pubAllocedArray[ulAllocedArraySize/2];
! 		IntData.pubEndIndex   = &pubAllocedArray[ulAllocedArraySize-1];
  	}
  	else
  	{
  		IntData.pubHalfIndex  = NULL;
! 		IntData.pubEndIndex   = NULL;
  	}
  	Enable();
--- 1091,1105 ----
  	/* Initialize arg struct for inthandler */
  	Disable();
! 	IntData.pubIndex	  = pubAllocedArray;
! 	IntData.pubArray	  = pubAllocedArray;
  	if (pubAllocedArray)
  	{
  		IntData.pubHalfIndex  = &pubAllocedArray[ulAllocedArraySize/2];
! 		IntData.pubEndIndex	  = &pubAllocedArray[ulAllocedArraySize-1];
  	}
  	else
  	{
  		IntData.pubHalfIndex  = NULL;
! 		IntData.pubEndIndex	  = NULL;
  	}
  	Enable();
***************
*** 1073,1077 ****
  	Disable();
  	*ft->ciahi = ((uwMicros & 0xFF00)>>8);
! 	*ft->cialo =  (uwMicros & 0x00FF)    ;
  	Enable();
  }
--- 1128,1132 ----
  	Disable();
  	*ft->ciahi = ((uwMicros & 0xFF00)>>8);
! 	*ft->cialo =  (uwMicros & 0x00FF)	 ;
  	Enable();
  }
***************
*** 1083,1087 ****
   *
   * This routine makes no assumptions about which interval timers
!  * (if any) are available for use.  Currently there are two interval
   * timers per CIA chip.
   *
--- 1138,1142 ----
   *
   * This routine makes no assumptions about which interval timers
!  * (if any) are available for use.	Currently there are two interval
   * timers per CIA chip.
   *
***************
*** 1105,1109 ****
  	/* Try for CIA-A */
  	ft->ciabase = ciaabase;		/* library address for */
! 	ft->cia	= pciaa;
  	ft->BUsingCIAB = FALSE;
  	if (TryTimer(ft)) return(TRUE);
--- 1160,1164 ----
  	/* Try for CIA-A */
  	ft->ciabase = ciaabase;		/* library address for */
! 	ft->cia = pciaa;
  	ft->BUsingCIAB = FALSE;
  	if (TryTimer(ft)) return(TRUE);
***************
*** 1111,1117 ****
  	/* Couldn't get CIA-A, try for CIA-B */
  	ft->ciabase = ciabbase;
! 	ft->cia	    = pciab;
  	ft->BUsingCIAB = TRUE;
!  	return(TryTimer(ft));
  }
  
--- 1166,1172 ----
  	/* Couldn't get CIA-A, try for CIA-B */
  	ft->ciabase = ciabbase;
! 	ft->cia		= pciab;
  	ft->BUsingCIAB = TRUE;
! 	return(TryTimer(ft));
  }
  
***************
*** 1141,1145 ****
  /* returns success, or if BAlloc == CHECK_STATUS, returns TRUE if
     available, FALSE if not */
! /* Don't call this manually except to check_status!  StartSampling
     will call it as necessary! */
  BOOL AllocParallel(BOOL BAlloc, BOOL BGrab)
--- 1196,1200 ----
  /* returns success, or if BAlloc == CHECK_STATUS, returns TRUE if
     available, FALSE if not */
! /* Don't call this manually except to check_status!	 StartSampling
     will call it as necessary! */
  BOOL AllocParallel(BOOL BAlloc, BOOL BGrab)
***************
*** 1159,1167 ****
  			/* If another AmiPhone is using the parallel, we'll try to kick them off! */
  			if ((BGrab == TRUE)&&(strncmp(szCurrentUser, "AmiPhone", 8) == 0)&&
! 			    (TellOtherAmiPhoneToLetGo(szCurrentUser) == TRUE)) 
! 			    {
! 			    	Delay(5);	/* allow the other guy time to disengage */
! 			    	return(AllocParallel(TRUE, FALSE));
! 			    }
  			
  			sprintf(szMessage,"%s Parallel port in use.",pcErrType);
--- 1214,1222 ----
  			/* If another AmiPhone is using the parallel, we'll try to kick them off! */
  			if ((BGrab == TRUE)&&(strncmp(szCurrentUser, "AmiPhone", 8) == 0)&&
! 				(TellOtherAmiPhoneToLetGo(szCurrentUser) == TRUE)) 
! 				{
! 					Delay(5);	/* allow the other guy time to disengage */
! 					return(AllocParallel(TRUE, FALSE));
! 				}
  			
  			sprintf(szMessage,"%s Parallel port in use.",pcErrType);
***************
*** 1182,1186 ****
  	if ((BAlloc == FALSE)||(BAlloc == CHECK_STATUS))	
  	{		
! 		FreeMiscResource(MR_PARALLELBITS); 		
  		FreeMiscResource(MR_PARALLELPORT);
  	}			
--- 1237,1241 ----
  	if ((BAlloc == FALSE)||(BAlloc == CHECK_STATUS))	
  	{		
! 		FreeMiscResource(MR_PARALLELBITS);		
  		FreeMiscResource(MR_PARALLELPORT);
  	}			
***************
*** 1215,1219 ****
  	{
  		if (sigfull != 0) {FreeSignal(sigfull);	 sigfull = 0;}
! 		if (sighalf != 0) {FreeSignal(sighalf);  sighalf = 0;}
  	}	
  	return(TRUE);	
--- 1270,1274 ----
  	{
  		if (sigfull != 0) {FreeSignal(sigfull);	 sigfull = 0;}
! 		if (sighalf != 0) {FreeSignal(sighalf);	 sighalf = 0;}
  	}	
  	return(TRUE);	
***************
*** 1240,1249 ****
  	ulTemp >>= 2;
  
! 	/* compression algorithm specific size restrictions implemented here */	
  	switch(bComp)
  	{
  		case COMPRESS_ADPCM2: while (ulTemp % 2) ulTemp++; break;
  		case COMPRESS_ADPCM3: while (ulTemp % 3) ulTemp++; break;
! 		case COMPRESS_NONE:   while (ulTemp % 2) ulTemp++; break;
  	}
  	return(ulTemp);
--- 1295,1304 ----
  	ulTemp >>= 2;
  
! 	/* compression algorithm specific size restrictions implemented here */ 
  	switch(bComp)
  	{
  		case COMPRESS_ADPCM2: while (ulTemp % 2) ulTemp++; break;
  		case COMPRESS_ADPCM3: while (ulTemp % 3) ulTemp++; break;
! 		case COMPRESS_NONE:	  while (ulTemp % 2) ulTemp++; break;
  	}
  	return(ulTemp);
***************
*** 1254,1260 ****
  {
  	ubCurrComp = ubNewMode;
- 	
- 	/* Force reset! */
- 	if (ubSamplerType == SAMPLER_DELFINA) ChangeSampleSpeed(ulBytesPerSecond, ubCurrComp);
  }
  
--- 1309,1312 ----
***************
*** 1269,1283 ****
  		if ((ulNewBPS == 0)||(ulNewBPS > nMaxSampleRate)) ulNewBPS = T_FindFrequency(0);
  	}
! 	if (ubSamplerType == SAMPLER_DELFINA) ulNewBPS = GetClosestDelfRate(ulNewBPS, NULL, NULL);
! 	if ((ubSamplerType == SAMPLER_AHI)&&(ulAHIAudioMode)) ulNewBPS = AHI_FindFrequency(ulNewBPS);
  
  	/* make sure our sampling isn't too fast or too slow */
  	if (UsesCIAInterrupt())
! 	    	ulNewBPS = ChopValue(ulNewBPS, MIN_SAMPLE_RATE, nMaxSampleRate);
  
  	/* make sure our packets aren't too small  */
  	if (fPacketDelay < MIN_PACKET_INTERVAL) fPacketDelay = MIN_PACKET_INTERVAL;
  
! 	/* To keep a particular speed, add this:         */
  	/* if (bComp == COMPRESS_SDP1) ulNewBPS = 6000L; */
  
--- 1321,1334 ----
  		if ((ulNewBPS == 0)||(ulNewBPS > nMaxSampleRate)) ulNewBPS = T_FindFrequency(0);
  	}
! 	if ((ubSamplerType == SAMPLER_AHI)&&(ulAHIMode != AHI_INVALID_ID)) ulNewBPS = AHI_FindFrequency(ulNewBPS);
  
  	/* make sure our sampling isn't too fast or too slow */
  	if (UsesCIAInterrupt())
! 			ulNewBPS = ChopValue(ulNewBPS, MIN_SAMPLE_RATE, nMaxSampleRate);
  
  	/* make sure our packets aren't too small  */
  	if (fPacketDelay < MIN_PACKET_INTERVAL) fPacketDelay = MIN_PACKET_INTERVAL;
  
! 	/* To keep a particular speed, add this:		 */
  	/* if (bComp == COMPRESS_SDP1) ulNewBPS = 6000L; */
  
***************
*** 1294,1298 ****
  			
  			Disable();
! 			IntData.uwCiavals     = ulTimerDelay;
  			IntData.ulThreshhold  = (ULONG) (nMinSampleVol*255)/100;
  			UNLESS(IntData.BIdle) SetTimerCountdown(NULL,ulTimerDelay);
--- 1345,1349 ----
  			
  			Disable();
! 			IntData.uwCiavals	  = ulTimerDelay;
  			IntData.ulThreshhold  = (ULONG) (nMinSampleVol*255)/100;
  			UNLESS(IntData.BIdle) SetTimerCountdown(NULL,ulTimerDelay);
***************
*** 1315,1319 ****
  /* Go through and make the bytes in the buffer unsigned,
     and add up their total and return it as well */
! ULONG ProcessToccataBuffer(UBYTE * pubData, ULONG ulDataLen)
  {
  	register ULONG ulSum = 0L;
--- 1366,1370 ----
  /* Go through and make the bytes in the buffer unsigned,
     and add up their total and return it as well */
! static ULONG ProcessToccataBuffer(UBYTE * pubData, ULONG ulDataLen)
  {
  	register ULONG ulSum = 0L;
***************
*** 1332,1370 ****
  
  
! /* Turn the words in the buffer into bytes.  Note that the
!    ulDataLen parameter is the length of the buffer in BYTES,
!    and when the function returns, only the first half of
!    the buffer will be valid. */
  /* Returns the sample sum, just like ProcessToccataBuffer() */
  
! /* pubData    - pointer to the sampled buffer */
! /* ulDataLen  - in/out variable, sends in length of buffer at current
! 		bit-width, etc... returns out the length of buffer 
! 		in 8-bit mono */
! /* ulType     - The data type as given by AHI */
! ULONG ProcessAHIBuffer(UBYTE * pubData, ULONG * ulDataLen, ULONG ulType)
  {
  	register ULONG ulSum = 0L;
! 	register UBYTE ubTemp, ubReadDiff;
! 	register UBYTE * pubCurrentRead  = pubData;
! 	register UBYTE * pubCurrentWrite = pubData;
! 	register ULONG ulLeft;
  	
  	switch(ulType)
  	{
- 		case AHIST_M8S:   /* Mono, 8 bit signed (BYTE) */
- 			ubReadDiff = 1;
- 			break;
- 								
- 		case AHIST_M8U:   /* Mono, 8 bit unsigned (UBYTE) */
- 			ubReadDiff = 1;
- 			break;
- 			
- 		case AHIST_M16S:  /* Mono, 16 bit signed (WORD) */
- 			ubReadDiff = 2;
- 			break;
- 			
  		case AHIST_S16S:  /* Stereo 16 bit signed (2×WORD) */
- 			ubReadDiff = 4;
  			if (ubInputChannel == INPUT_JACK_RIGHT) pubCurrentRead += 2;
  			break;
--- 1383,1404 ----
  
  
! /* Turn the words in the buffer into bytes. */
  /* Returns the sample sum, just like ProcessToccataBuffer() */
  
! /* pubSrc	  - pointer to the sampled buffer */
! /* pubDst	  - pointer to the destination buffer */
! /* ulDataLen  - length is samples */
! /* ulType	  - The data type as given by AHI */
! static ULONG ProcessAHIBuffer(UBYTE * pubSrc, UBYTE * pubDst, ULONG ulDataLen, ULONG ulType)
  {
  	register ULONG ulSum = 0L;
! 	register UBYTE ubTemp = 0;
! 	register UBYTE * pubCurrentRead	 = pubSrc;
! 	register UBYTE * pubCurrentWrite = pubDst;
! 	register ULONG ulLeft = ulDataLen;
  	
  	switch(ulType)
  	{
  		case AHIST_S16S:  /* Stereo 16 bit signed (2×WORD) */
  			if (ubInputChannel == INPUT_JACK_RIGHT) pubCurrentRead += 2;
  			break;
***************
*** 1375,1386 ****
  	}
  	
- 	*ulDataLen = ulLeft = (*ulDataLen)/ubReadDiff;
- 	
  	while(ulLeft--)
  	{
! 		ubTemp = ((*pubCurrentRead)-128)<<nAmpShift;
! 		ulSum += ubTemp;
  		*pubCurrentWrite = ubTemp;
! 		pubCurrentRead += ubReadDiff; pubCurrentWrite++;
  	}
  	return(ulSum);
--- 1409,1419 ----
  	}
  	
  	while(ulLeft--)
  	{
! 		ubTemp = (*pubCurrentRead)<<nAmpShift;
  		*pubCurrentWrite = ubTemp;
! 		ulSum += ubTemp;
! 		pubCurrentRead += 4;
! 		pubCurrentWrite++;
  	}
  	return(ulSum);
***************
*** 1400,1404 ****
  	{
  		ulMaxArrayCount = ulSampleArraySize << 6;
! 		ulVolume >>= 4;	/* It's still a mystery to me why this is 16 times too big! */
  	}
  	else
--- 1433,1437 ----
  	{
  		ulMaxArrayCount = ulSampleArraySize << 6;
! 		ulVolume >>= 4; /* It's still a mystery to me why this is 16 times too big! */
  	}
  	else
***************
*** 1420,1424 ****
  	{
  		case SAMPLER_GVPDSS8:	ulVol <<= 1; break;
! 		case SAMPLER_TOCCATA:   ulVol <<= 2; break;
  	}
  	
--- 1453,1457 ----
  	{
  		case SAMPLER_GVPDSS8:	ulVol <<= 1; break;
! 		case SAMPLER_TOCCATA:	ulVol <<= 2; break;
  	}
  	
***************
*** 1437,1441 ****
  
  /* If nBytes == ALL_OF_BUFFER, transmit the whole buffer section.
!    Otherwise, transmit the first nBytes of the indicated buffer. */   
  void TransmitData(UBYTE * pubStart, int nBytes, int bComp)
  {
--- 1470,1474 ----
  
  /* If nBytes == ALL_OF_BUFFER, transmit the whole buffer section.
!    Otherwise, transmit the first nBytes of the indicated buffer. */	  
  void TransmitData(UBYTE * pubStart, int nBytes, int bComp)
  {
***************
*** 1443,1447 ****
  	BOOL BSoundWasOnBefore = BSoundOn;
  	static ULONG ulSaveJoin = 0L, ulJoinCode = 0L;
! 	static int nPostGracePeriod = nPostSendLen;
  			
  	if (nBytes == 0)
--- 1476,1482 ----
  	BOOL BSoundWasOnBefore = BSoundOn;
  	static ULONG ulSaveJoin = 0L, ulJoinCode = 0L;
! 	static int nPostGracePeriod;
! 
!   nPostGracePeriod = nPostSendLen;
  			
  	if (nBytes == 0)
***************
*** 1454,1460 ****
  
  	/* Was there enough sound there to transmit? */
! 	if (ubSamplerType == SAMPLER_DELFINA)
! 		ulLastVolume = IntData.ulSaveByteSum = DelfPacket(sendBuf.ubData, nBytes, &ulSaveJoin);
! 	   else ulLastVolume = IntData.ulSaveByteSum;
  	   
  	if (CalcVolumePercentage(ulLastVolume) < nMinSampleVol)
--- 1489,1493 ----
  
  	/* Was there enough sound there to transmit? */
!   ulLastVolume = IntData.ulSaveByteSum;
  	   
  	if (CalcVolumePercentage(ulLastVolume) < nMinSampleVol)
***************
*** 1462,1467 ****
  		/* This section entered if the current buffer is too quiet */
  		if (nPostGracePeriod > 0) 
! 		     nPostGracePeriod--; /* time is running out to hear something! */
! 		else BSoundOn = FALSE;	 /* time's up!  Shut off the transmission! */
  	}
  	else 
--- 1495,1500 ----
  		/* This section entered if the current buffer is too quiet */
  		if (nPostGracePeriod > 0) 
! 			 nPostGracePeriod--; /* time is running out to hear something! */
! 		else BSoundOn = FALSE;	 /* time's up!	Shut off the transmission! */
  	}
  	else 
***************
*** 1488,1506 ****
  		/* Prepare/compress the packet */
  		sendBuf.header.ubCommand  = PHONECOMMAND_DATA;
! 		sendBuf.header.ubType     = bComp;
  		sendBuf.header.ulBPS	  = ulBytesPerSecond;
  		sendBuf.header.ulJoinCode = ulJoinCode;
  
! 		if (ubSamplerType == SAMPLER_DELFINA)
! 		{
! 			/* Compression was done by the Delfina's DSP, 
! 			   all we need to do here is get the next ulJoinCode */
! 			sendBuf.header.ulDataLen = nBytes;
! 		}
! 		else
! 		{
! 			/* Do the compression ourselves! */
! 			sendBuf.header.ulDataLen  = CompressData(pubStart,sendBuf.ubData,bComp,ulLength,&ulJoinCode);
! 		}	
  	}
  
--- 1521,1529 ----
  		/* Prepare/compress the packet */
  		sendBuf.header.ubCommand  = PHONECOMMAND_DATA;
! 		sendBuf.header.ubType	  = bComp;
  		sendBuf.header.ulBPS	  = ulBytesPerSecond;
  		sendBuf.header.ulJoinCode = ulJoinCode;
  
! 		sendBuf.header.ulDataLen  = CompressData(pubStart,sendBuf.ubData,bComp,ulLength,&ulJoinCode);
  	}
  
***************
*** 1519,1525 ****
  	}	
  
- 	/* For Delfina:  *Now* update ulJoinCode, AFTER we've set sendBuf.header.ulJoinCode */
- 	if (ubSamplerType == SAMPLER_DELFINA) ulJoinCode = ulSaveJoin;
- 
  	/* If we're doing hold-to-transmit and button is no longer being held, turn sampler off */
  	if ((nToggleMode == TOGGLE_HOLD)&&(BButtonHeld == FALSE)) ToggleMicButton(CODE_OFF);
--- 1542,1545 ----
***************
*** 1556,1560 ****
  
  /* Empty the presend queue, either with or without transmitting packets */
! void FlushPreSendQueue(BOOL BTransmit, BOOL BTCP)
  {	
  	struct Node * current;
--- 1576,1580 ----
  
  /* Empty the presend queue, either with or without transmitting packets */
! static void FlushPreSendQueue(BOOL BTransmit, BOOL BTCP)
  {	
  	struct Node * current;
***************
*** 1567,1571 ****
  }
  
! void FreePreSendNode(struct Node * current)
  {
  	struct AmiPhoneSendBuffer * packet = current->ln_Name;
--- 1587,1591 ----
  }
  
! static void FreePreSendNode(struct Node * current)
  {
  	struct AmiPhoneSendBuffer * packet = current->ln_Name;
***************
*** 1576,1580 ****
  }
  
! void UpdatePreSendQueue(struct AmiPhoneSendBuffer * sBuf)
  {
  	struct AmiPhoneSendBuffer * newPacket;
--- 1596,1600 ----
  }
  
! static void UpdatePreSendQueue(struct AmiPhoneSendBuffer * sBuf)
  {
  	struct AmiPhoneSendBuffer * newPacket;
***************
*** 1631,1636 ****
  	if (ubBitCode & SAMPBIT_POUTSET) SETCIA(CIAF_PRTRPOUT);
  	
! 	if (ubBitCode & SAMPBIT_SELCLR)  CLRCIA(CIAF_PRTRSEL);
! 	if (ubBitCode & SAMPBIT_SELSET)  SETCIA(CIAF_PRTRSEL);
  	
  	if (ubBitCode & SAMPBIT_BUSYCLR) CLRCIA(CIAF_PRTRBUSY);
--- 1651,1656 ----
  	if (ubBitCode & SAMPBIT_POUTSET) SETCIA(CIAF_PRTRPOUT);
  	
! 	if (ubBitCode & SAMPBIT_SELCLR)	 CLRCIA(CIAF_PRTRSEL);
! 	if (ubBitCode & SAMPBIT_SELSET)	 SETCIA(CIAF_PRTRSEL);
  	
  	if (ubBitCode & SAMPBIT_BUSYCLR) CLRCIA(CIAF_PRTRBUSY);
***************
*** 1651,1656 ****
  	if (ubBitCode & SAMPBIT_POUTSET) SETDCIA(CIAF_PRTRPOUT);
  	
! 	if (ubBitCode & SAMPBIT_SELCLR)  CLRDCIA(CIAF_PRTRSEL);
! 	if (ubBitCode & SAMPBIT_SELSET)  SETDCIA(CIAF_PRTRSEL);
  	
  	if (ubBitCode & SAMPBIT_BUSYCLR) CLRDCIA(CIAF_PRTRBUSY);
--- 1671,1676 ----
  	if (ubBitCode & SAMPBIT_POUTSET) SETDCIA(CIAF_PRTRPOUT);
  	
! 	if (ubBitCode & SAMPBIT_SELCLR)	 CLRDCIA(CIAF_PRTRSEL);
! 	if (ubBitCode & SAMPBIT_SELSET)	 SETDCIA(CIAF_PRTRSEL);
  	
  	if (ubBitCode & SAMPBIT_BUSYCLR) CLRDCIA(CIAF_PRTRBUSY);
***************
*** 1658,1662 ****
  
  	if ((ubSamplerType == SAMPLER_CUSTOM)&&
! 	    (ubBitCode != (SAMPBIT_POUTSET | SAMPBIT_SELSET | SAMPBIT_BUSYSET))) printf("SetDirectionBits:  Executed %s, direction bits are now %s\n",BitsToString(ubBitCode),RegToString(pciab->ciaddra));
  }
  
--- 1678,1682 ----
  
  	if ((ubSamplerType == SAMPLER_CUSTOM)&&
! 		(ubBitCode != (SAMPBIT_POUTSET | SAMPBIT_SELSET | SAMPBIT_BUSYSET))) printf("SetDirectionBits:	Executed %s, direction bits are now %s\n",BitsToString(ubBitCode),RegToString(pciab->ciaddra));
  }
  
***************
*** 1684,1688 ****
  		(ubReg & CIAF_PRTRPOUT) != 0,
  		(ubReg & CIAF_PRTRBUSY) != 0,
! 		(ubReg & CIAF_PRTRSEL)  != 0);
  	
  	return(szResult);
--- 1704,1708 ----
  		(ubReg & CIAF_PRTRPOUT) != 0,
  		(ubReg & CIAF_PRTRBUSY) != 0,
! 		(ubReg & CIAF_PRTRSEL)	!= 0);
  	
  	return(szResult);
***************
*** 1696,1710 ****
  	struct TagItem taglist[3];
  
! 	taglist[0].ti_Tag  = AHIDB_Index; 	taglist[0].ti_Data  = &ulIndex;
! 	taglist[1].ti_Tag  = AHIDB_IndexArg; 	taglist[1].ti_Data  = ulBPS;
! 	taglist[2].ti_Tag  = TAG_DONE;		taglist[2].ti_Data  = NULL;
! 	if (AHI_GetAudioAttrsA(ulAHIAudioMode, NULL, taglist))
! 	{
! 		printf("AHI_FindFrequency: Nearest index = %lu\n",ulIndex);
! 		taglist[0].ti_Tag  = AHIDB_Frequency; 	taglist[0].ti_Data  = &ulFreq;
! 		taglist[1].ti_Tag  = AHIDB_FrequencyArg;taglist[1].ti_Data  = ulIndex;
! 		if (AHI_GetAudioAttrsA(ulAHIAudioMode, NULL, taglist))
  		{
! 			printf("AHI_FindFrequency: Frequency to use:  %lu\n",ulFreq);
  			return(ulFreq);
  		}
--- 1716,1730 ----
  	struct TagItem taglist[3];
  
! 	taglist[0].ti_Tag  = AHIDB_Index;	taglist[0].ti_Data	= &ulIndex;
! 	taglist[1].ti_Tag  = AHIDB_IndexArg;	taglist[1].ti_Data	= ulBPS;
! 	taglist[2].ti_Tag  = TAG_DONE;		taglist[2].ti_Data	= NULL;
! 	if (AHI_GetAudioAttrsA(ulAHIMode, NULL, taglist))
! 	{
! //		printf("AHI_FindFrequency: Nearest index = %lu\n",ulIndex);
! 		taglist[0].ti_Tag  = AHIDB_Frequency;	taglist[0].ti_Data	= &ulFreq;
! 		taglist[1].ti_Tag  = AHIDB_FrequencyArg;taglist[1].ti_Data	= ulIndex;
! 		if (AHI_GetAudioAttrsA(ulAHIMode, NULL, taglist))
  		{
! //			printf("AHI_FindFrequency: Frequency to use:  %lu\n",ulFreq);
  			return(ulFreq);
  		}
Only in ../AmiPhone_1.92: ciatimer.c.info
diff -r -C 2 -P ../AmiPhone_1.92/ciatimer.h ./ciatimer.h
*** ../AmiPhone_1.92/ciatimer.h	Sat Nov 16 23:46:40 1996
--- ./ciatimer.h	Mon Feb 16 23:09:58 1998
***************
*** 44,53 ****
  BOOL SetupPreSendQueue(BOOL BSetup);
  
- ULONG ProcessToccataBuffer(UBYTE * pubData, ULONG ulDataLen);
- ULONG ProcessAHIBuffer(UBYTE * pubData, ULONG * ulDataLen, ULONG ulType);
- 
  void TransmitData(UBYTE * pubStart, int ulLength, int bTransmitMode);
  void ChangeInputChannel(int nNewChannel);
  void ChangeSamplerType(int nNewSamplerType);
  void ChangeInputSource(int nNewSource, BOOL BMakePermanent);
  void ChangeCompressMode(UBYTE ubNewMode);
--- 44,51 ----
  BOOL SetupPreSendQueue(BOOL BSetup);
  
  void TransmitData(UBYTE * pubStart, int ulLength, int bTransmitMode);
  void ChangeInputChannel(int nNewChannel);
  void ChangeSamplerType(int nNewSamplerType);
+ void ChangeAHIMode(void);
  void ChangeInputSource(int nNewSource, BOOL BMakePermanent);
  void ChangeCompressMode(UBYTE ubNewMode);
diff -r -C 2 -P ../AmiPhone_1.92/codec.c ./codec.c
*** ../AmiPhone_1.92/codec.c	Sat Nov 16 23:46:38 1996
--- ./codec.c	Sun Feb 15 23:04:26 1998
***************
*** 1,8 ****
--- 1,10 ----
  #ifndef CODEC_C
  #define CODEC_C
+ /* :ts=4 */
  
  /* codec.c : routines shared by AmiPhone AND AmiPhoned--govern audio
     	     compression, decompression, and playing */
  
+ #include <netinclude:sys/types.h>
  #include <stdio.h>
  #include <string.h>
***************
*** 224,228 ****
  	}
  	return(TRUE);
! };
  
  
--- 226,230 ----
  	}
  	return(TRUE);
! }
  
  
Only in ../AmiPhone_1.92: codec.c.info
diff -r -C 2 -P ../AmiPhone_1.92/compress/ADPCM2_Crunch.a ./compress/ADPCM2_Crunch.a
*** ../AmiPhone_1.92/compress/ADPCM2_Crunch.a	Sat Nov 16 23:46:46 1996
--- ./compress/ADPCM2_Crunch.a	Sun Feb 15 18:40:33 1998
***************
*** 20,25 ****
  
  
! 		XDEF @CompressADPCM2
! @CompressADPCM2
  		movem.l	d2-d4,-(sp)
  
--- 20,25 ----
  
  
! 		XDEF _CompressADPCM2
! _CompressADPCM2
  		movem.l	d2-d4,-(sp)
  
diff -r -C 2 -P ../AmiPhone_1.92/compress/ADPCM2_Decrunch.a ./compress/ADPCM2_Decrunch.a
*** ../AmiPhone_1.92/compress/ADPCM2_Decrunch.a	Sat Nov 16 23:46:46 1996
--- ./compress/ADPCM2_Decrunch.a	Sun Feb 15 18:40:29 1998
***************
*** 26,31 ****
  	;
  
! 		XDEF @DecompressADPCM2
! @DecompressADPCM2
  		movem.l	d2-d4,-(sp)
  
--- 26,31 ----
  	;
  
! 		XDEF _DecompressADPCM2
! _DecompressADPCM2
  		movem.l	d2-d4,-(sp)
  
diff -r -C 2 -P ../AmiPhone_1.92/compress/ADPCM3_Crunch.a ./compress/ADPCM3_Crunch.a
*** ../AmiPhone_1.92/compress/ADPCM3_Crunch.a	Sat Nov 16 23:46:46 1996
--- ./compress/ADPCM3_Crunch.a	Sun Feb 15 18:40:26 1998
***************
*** 18,23 ****
  	; Function of the JoinCode: See above.
  
! 		XDEF @CompressADPCM3
! @CompressADPCM3
  		movem.l	d2-d4,-(sp)
  
--- 18,23 ----
  	; Function of the JoinCode: See above.
  
! 		XDEF _CompressADPCM3
! _CompressADPCM3
  		movem.l	d2-d4,-(sp)
  
diff -r -C 2 -P ../AmiPhone_1.92/compress/ADPCM3_Decrunch.a ./compress/ADPCM3_Decrunch.a
*** ../AmiPhone_1.92/compress/ADPCM3_Decrunch.a	Sat Nov 16 23:46:46 1996
--- ./compress/ADPCM3_Decrunch.a	Sun Feb 15 18:40:23 1998
***************
*** 28,33 ****
  	;
  
! 		XDEF @DecompressADPCM3
! @DecompressADPCM3
  		movem.l	d2-d4,-(sp)
  
--- 28,33 ----
  	;
  
! 		XDEF _DecompressADPCM3
! _DecompressADPCM3
  		movem.l	d2-d4,-(sp)
  
Only in ../AmiPhone_1.92: delfph.c
Only in ../AmiPhone_1.92: delfph.c.info
Only in ../AmiPhone_1.92: delfph.h
Only in ../AmiPhone_1.92: delfphone.c
diff -r -C 2 -P ../AmiPhone_1.92/dmakefile ./dmakefile
*** ../AmiPhone_1.92/dmakefile	Sat Nov 16 23:46:48 1996
--- ./dmakefile	Sun Feb 15 12:47:03 1998
***************
*** 1,4 ****
  SCC = dcc -proto
! ASM = phxass I=include:amiga SD SC
  
  ASM_OBJS  = inthandler.o compress/ADPCM2_Crunch.o compress/ADPCM3_Crunch.o compress/ADPCM2_Decrunch.o compress/ADPCM3_Decrunch.o
--- 1,4 ----
  SCC = dcc -proto
! ASM = phxass SD SC
  
  ASM_OBJS  = inthandler.o compress/ADPCM2_Crunch.o compress/ADPCM3_Crunch.o compress/ADPCM2_Decrunch.o compress/ADPCM3_Decrunch.o
Only in ../AmiPhone_1.92: dmakefile.info
